/* -*- mode: c++; c-basic-offset: 3; -*- */
#include "html/genAttr.hh"
#include "html/writer.hh"

using namespace html;
using namespace std;

//======================================  Constructor
genAttr::genAttr(const std::string& value)
   : mValue(value)
{}

//======================================  Destructor
genAttr::~genAttr(void) {}

//======================================  Clone this attribute
genAttr* 
genAttr::clone(void) const {
   return new genAttr(*this);
}

//======================================  Append to a string.
void 
genAttr::append(const attrib& x, int sep) {
   auto genX = dynamic_cast<const genAttr*>(&x);
   if (genX) {
      if (!mValue.empty()) mValue += string::value_type(sep);
      mValue += genX->mValue;
   }
}

//======================================  Test for default
bool 
genAttr::isDefault(void) const {
   return mValue.empty();
}

//======================================  Keyword only attribute
bool
genAttr::hasArg(void) const {
   return true;
}

//======================================  Set string value
void 
genAttr::setValue(const std::string& value) {
   mValue = value;
}

//======================================  Assignment operator
bool 
genAttr::operator==(const genAttr& x) const {
   return mValue == x.mValue;
}
